Whamcloud - gitweb
f18a5a31b502510f0a377f9225332d0a2c008537
[fs/lustre-release.git] / build / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 # this is an alternative FD for stdout, to be used especially when we are
6 # taking stdout from a function as it's return value.  i.e. foo=$(bar)
7 # this is a workaround until a version of bash where we can put xtrace
8 # on a specific FD
9 exec 3>&1; STDOUT=3
10
11 #set -x
12 xtrace="+x"
13 if [[ $SHELLOPTS = *xtrace* ]]; then
14     xtrace="-x"
15 fi
16 shopt -s extdebug
17
18 # include the exit_traps library
19 . ${0%/lbuild}/exit_traps.sh
20
21 # our children should die when we do
22 push_exit_trap "kill -INT -$$ || true" kill_children
23
24 # increment this if you have made a change that should force a new kernel
25 # to build built
26 #BUILD_GEN=1
27 #BUILD_GEN=2    # bz19952: remove -lustre tag from kernel RPM names
28 #BUILD_GEN=3    # bz19975: enable the building of src.rpms by default
29 BUILD_GEN=4     # bz22281: use the git hash in the kernel extra version
30
31 TOPDIR=$PWD
32
33 # CVSROOT is inherited from the environment
34 KERNELDIR=
35 LINUX=
36 LUSTRE=
37 RELEASE=false
38 # XXX - some recent hacking has pretty much neutered this option.
39 #       search through this file (and lbuild.old_school -- but that will
40 #       be going away soon) for "-bb" and see how many places
41 #       simply don't account for this option
42 DO_SRC=true
43 DOWNLOAD=true
44 TAG=
45 CANONICAL_TARGET=
46 TARGET=
47 TARGET_ARCH=$(uname -m)
48 TARGET_ARCHS=
49 TARGET_ARCHS_ALL=$TARGET_ARCH
50 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
51 CONFIGURE_FLAGS=
52 EXTERNAL_PATCHES=
53 EXTRA_VERSION=
54 STAGEDIR=
55 TMPDIR=${TMPDIR:-"/var/tmp"}
56 TIMESTAMP=
57 # this is a dir to try reuse old kernel RPMs in (although, it seems to be
58 # unused in any real manner
59 REUSERPM=
60 # this is the dir that should be used to store reuse products
61 REUSEBUILD=
62 # should cached products be used or force rebuilding?
63 USE_BUILD_CACHE=true
64 # what does this do exactly?  does it imply no kernel build?
65 NORPM=false
66 LDISKFSRPM=true
67 SKIPLDISKFSRPM="v1_4_* b1_4"
68 SMPTYPES="smp bigsmp default ''"
69 PATCHLESS=false
70 XEN=false
71 LINUXOBJ=
72 DISTRO=
73 KERNELTREE=
74 # default to not adding -lustre- into the kernel RPM package names
75 KERNEL_LUSTRE_NAMING=false
76
77 # patchless build
78 KERNELRPMSBASE=
79 RPMSMPTYPE=
80
81 # from target file
82 SERIES=
83 BASE_ARCHS=
84 BIGMEM_ARCHS=
85 BOOT_ARCHS=
86 JENSEN_ARCHS=
87 SMP_ARCHS=
88 BIGSMP_ARCHS=
89 PSERIES64_ARCHS=
90 UP_ARCHS=
91
92 # not in the target file any more
93 CONFIG=
94
95 # build the lustre-tests rpm?
96 LUSTRE_TESTS=true
97
98 DATE=$(date)
99
100 USE_DATESTAMP=1
101 RPMBUILD=
102
103 OLD_SCHOOL=false
104
105 export CC=${CC:-gcc}
106
107 # Readlink is not present on some older distributions: emulate it.
108 readlink() {
109     local path=$1 ll
110
111     if [ -L "$path" ]; then
112         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
113         echo "${ll/* -> }"
114     else
115         return 1
116     fi
117 }
118
119 cleanup() {
120
121     true
122 }
123
124 error() {
125     local msg="$1"
126
127     [ -n "$msg" ] && echo -e "\n${0##*/}: $msg" >&3
128
129 }
130
131 fatal() {
132
133     cleanup
134     error "$2"
135     exit $1
136
137 }
138
139 usage() {
140     cat <<EOF
141 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
142
143   -d CVSROOT
144     Specifies the CVS Root to use when pulling files from CVS.  The
145     environment variable \$CVSROOT is used if this option is not
146     present.
147
148   --external-patches=EXTERNAL_PATCHES
149     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
150     look for seres and config files in before looking in the lustre
151     tree.
152
153   --extraversion=EXTRAVERSION
154     Text to use for the rpm release and kernel extraversion.
155
156   --timestamp=TIMESTAMP
157     Date of building lustre in format YYYYMMDDhhmmss
158
159   --reuserpm=DIR
160     Try to reuse old kernel RPMs from DIR
161
162   --reusebuild=DIR
163     Try to reuse old kernel builds from DIR
164
165   --kernelrpm=DIR
166     Path to distro kernel RPM collection
167
168   --ccache
169     Use ccache
170
171   --norpm
172     Do not build RPMs (compile only mode)
173
174   --patchless
175     Build lustre client only
176
177   --distro=DISTRO
178     Which distro using. Autodetect by default
179
180   --kerneldir=KERNELDIR
181     Directory containing Linux source tarballs referenced by target
182     files.
183
184   --kerneltree=KERNELTREE
185     Directory containing dirs with Linux source tarballs referenced by target
186     files. Dir names in format kernel version ('2.6.9', etc.)
187
188   --linux=LINUX --with-linux=LINUX
189     Directory of Linux kernel sources.  When this option is used, only
190     Lustre modules and userspace are built.
191
192   --lustre=LUSTRE
193     Path to an existing lustre source tarball to use instead of
194     pulling from CVS.
195
196   --nodownload
197     Do not try to download a kernel from downloads.lustre.org
198
199   --nosrc
200     Do not build a .src.rpm, a full kernel patch, or a patched kernel
201     tarball.
202
203   --ldiskfs
204     Do ldiskfs RPM. Now true by default
205
206   --publish
207     Unused.
208
209   --release
210     Specifies that the files generated do not include timestamps, and
211     that this is an official release.
212
213   --src
214     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
215
216   --stage=DIR
217     Directory used to stage packages for release.  RPMs will be placed
218     more or less in DIR/<target>-<arch>, and the tarball will be
219     placed in DIR.
220
221   --tag=TAG
222     A CVS branch/tag name to build from when pulling from CVS.
223
224   --target=TARGET
225     The name of the target to build.  The available targets are listed
226     below.
227
228   --target-archs=TARGET_ARCHS
229     A (space delimited) list of architectures to build.  By default,
230     all of the archs supported by the TARGET will be built, in
231     addition to a .src.rpm.  This option can limit those, for machines
232     that can only build certain archs or if you only want a certain
233     arch built (for testing, or a one-off kernel).
234
235     Also note that by using a non-"base" arch (eg, i386) only kernels
236     will be built - there will be no lustre-lite-utils package.
237
238   --disable-datestamp
239     Prevents the datestamp flag (-D) from being passed to cvs for
240     checkouts. This is a workaround for a problem encountered when
241     using lbuild with tinderbox.
242
243   --xen
244     Builds a Xen domX kernel.
245
246   --set-value
247     Set's a variable to a given value.
248
249 EOF
250
251 #   list_targets
252
253     fatal "$1" "$2"
254 }
255
256 # canonicalize a relative path to a file
257 canon_filepath() {
258     local PATH="$1"
259
260     if [ ! -f "$PATH" ]; then
261         return 1
262     fi
263
264     local FILE=${PATH##*/}
265     local DIR=${PATH%/*}
266
267     echo $(canon_path "$DIR")/$FILE
268     return 0
269 }
270
271 # canonicalize a relative path to a dir
272 canon_path() {
273     local PATH="$1"
274
275     if [ ! -d "$PATH" ]; then
276         return 1
277     fi
278
279     pushd "$PATH" >/dev/null || return 1
280     local CANONPATH=$PWD
281     popd >/dev/null
282
283     echo "$CANONPATH"
284     return 0
285 }
286
287 check_options() {
288
289     if [ "$LUSTRE" ]; then
290         [ -r "$LUSTRE" ] || \
291             usage 1 "Could not find Lustre source tarball '$LUSTRE'."
292     else
293         [ "$CVSROOT" ] || \
294             usage 1 "Either specify a CVS Root with -d, or a Lustre source tarball with --lustre."
295         [ "$TAG" ] || \
296             usage 1 "A branch/tag name must be specified with --tag when not building from a tarball."
297     fi
298
299     if [ -z "$LINUX" ]; then
300         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
301             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
302
303         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
304             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
305
306         if ! $RELEASE; then
307             [ "$TAG" ] || \
308                 usage 1 "When building a snapshot, a tag name must be used."
309         fi
310
311         [ "$TARGET" ] || usage 1 "A target must be specified with --target."
312 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
313 #       [ -r "$TARGET_FILE" ] || \
314 #               usage 1 "Target '$TARGET' was not found."
315     fi
316
317     case $TARGET in
318         2.6-rhel5)
319             CANONICAL_TARGET="rhel5"
320             ;;
321         2.6-rhel4)
322             CANONICAL_TARGET="rhel-2.6"
323             ;;
324         2.6-suse)
325             CANONICAL_TARGET="sles-2.6"
326             ;;
327         2.6-sles10)
328             CANONICAL_TARGET="sles10-2.6"
329             ;;
330         2.6-sles11)
331             CANONICAL_TARGET="sles11"
332             ;;
333         2.6-oel5)
334             CANONICAL_TARGET="oel5"
335             ;;
336         hp_pnnl-2.4)
337             CANONICAL_TARGET="hp-pnnl-2.4"
338             ;;
339         2.6-vanilla \
340             | suse-2.4.21-2 \
341             | rh-2.4 \
342             | rhel-2.4 \
343             | sles-2.4 \
344             | 2.6-patchless)
345                 CANONICAL_TARGET="$TARGET"
346                 ;;
347     esac
348
349     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
350     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
351     local timestamplength="${#TIMESTAMP}"
352     if [ $timestamplength -eq 12 ]; then
353         TIMESTAMP="${TIMESTAMP}00"
354     elif [ $timestamplength -ne 14 ]; then
355         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
356     fi
357
358     RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
359     if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
360         RPMBUILD=$(which rpm 2>/dev/null | head -1)
361         if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
362             usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
363         fi
364     fi
365
366     if [ -n "$CCACHE" ]; then
367         which "$DISTCC" &>/dev/null && export DISTCC RPM_BUILD_NCPUS
368
369         if which "$CCACHE" &>/dev/null; then
370             local ccache=$(which "$CCACHE")
371             local bindir="$TOPDIR/bin"
372
373             if [ ! -d $bindir ]; then
374                 mkdir -p $bindir || fatal 1 "error trying to create $bindir"
375             else
376                 rm ${bindir}/* > /dev/null 2>&1 || true
377             fi
378             ln -s "$ccache" ${bindir}/ccache
379             ln -s "$ccache" ${bindir}/cc
380             ln -s "$ccache" ${bindir}/$CC
381             export PATH=$bindir:$PATH
382             export CCACHE && export CC="ccache $CC"
383             # zero the cache so we can see how effective we are being with it
384             echo -n "ccache "
385             ccache -z
386
387             # get some ccache stats when we are done
388             push_exit_trap '[ -n "$CCACHE" ] && ccache -s' "ccache_summary"
389             # should remove the ccache trap if lbuild is interrupted
390             trap 'echo "Received an INT TERM or HUP signal, terminating."; delete_exit_trap "ccache_summary"; exit 1' INT TERM HUP
391         fi
392     fi
393
394     [ -z "$DISTRO" ] && DISTRO=$(autodetect_distro)
395
396     return 0
397
398 }
399
400 # autodetect used Distro
401 autodetect_distro() {
402
403     local name
404     local version
405
406     if [ -f /etc/SuSE-release ]; then
407         name=sles
408         version=$(grep ^VERSION /etc/SuSE-release)
409         version=${version#*= }
410     elif [ -f /etc/redhat-release ]; then
411         name=$(head -1 /etc/redhat-release)
412         version=$(echo "$distroname" |
413                   sed -e 's/^[^0-9.]*//g' | sed -e 's/[ \.].*//')
414     fi
415     if [ -z "$name" -o -z "$version" ]; then
416         fatal 1 "I don't know how to determine distro type/version.\nEither update autodetect_distro() or use the --distro argument"
417     fi
418
419     echo ${name}${version}
420     return 0
421
422 }
423
424 uniqify() {
425
426     echo $(echo "$*" | xargs -n 1 | sort -u)
427
428 }
429
430 download_srpm() {
431     local target=$1
432     local srpm=$2
433     local force="${3:-false}"
434
435     if $force || [ ! -r "$KERNELDIR/$srpm" ] ||
436        [ ! -s "$KERNELDIR/$srpm" ]; then
437         if $DOWNLOAD; then
438             local location="http://downloads.lustre.org/public/kernels/$target/old"
439             echo "Downloading $location/$srpm..."
440             if ! wget -nv "$location/$srpm" -O "$KERNELDIR/$srpm" 2>&1 ||
441                [ ! -s "$KERNELDIR/$srpm" ]; then
442                 rm -f $KERNELDIR/$srpm
443                 fatal 1 "Could not download target $target's kernel SRPM $srpm from $location."
444             fi
445         else
446             fatal 1 "$srpm not found in directory $KERNELDIR."
447         fi
448     fi
449
450 }
451
452 download_file() {
453     local from="$1"
454     local to="$2"
455     local force="$3"
456
457     local file=${from##*/}
458
459     if [ -d $to ]; then
460         to="$to/$file"
461     fi
462
463     local semaphore="$to-downloading"
464
465     is_downloading() {
466         if [ ! -f $semaphore ]; then
467             return 1
468         fi
469
470         # make sure the download has not been aborted
471         local now=$(date +%s)
472         local file_mtime=$(stat -c %Y "$to")
473         local staleness=$((now - file_mtime))
474         # let's assume an active download will write at least once a minute
475         if [ $staleness -gt 60 ]; then
476             return 1
477         fi
478
479         return 0
480     }
481
482     is_downloaded() {
483         # if the semaphore file exists, the file is either still downloading
484         # or a download was aborted and we cannot trust the target file
485         if [ -f $semaphore ]; then
486             return 1
487         fi
488
489         if ! is_downloading && [ -r "$to" ] && [ -s "$to" ]; then
490             return 0
491         fi
492
493         return 1
494     }
495
496     if $force || ! is_downloaded; then
497         if is_downloading; then
498             echo "Somebody else is downloading $from..."
499             while is_downloading; do
500                 echo "Waiting for $to to finish downloading"
501                 sleep 60
502             done
503             if is_downloaded; then
504                 return 0
505             else
506                 echo "The download we were waiting for seems to have been aborted"
507             fi
508
509         fi
510
511         if $DOWNLOAD; then
512             echo "Downloading $from..."
513             # flag others so they don't try to download also
514             push_exit_trap "rm -f $to $semaphore" "download"
515             touch $semaphore
516             if ! wget -nv "$from" -O "$to" || [ ! -s "$to" ]; then
517                 # the trap will remove the files via the fatal below
518                 fatal 1 "Could not download ${to##*/} from ${from%/*}/."
519             fi
520             rm -f $semaphore
521             delete_exit_trap "download"
522         else
523             fatal 1 "${to##*/} not found in directory ${to%/*}."
524         fi
525     fi
526
527     return 0
528
529 }
530
531 download_ofed() {
532     local force="${1:-false}"
533
534     if [ -z "$OFED_VERSION" -o "$OFED_VERSION" = "inkernel" ]; then
535         return 0
536     fi
537
538     local location="http://www.openfabrics.org/downloads/OFED/ofed-${OFED_VERSION}/"
539
540     if [[ $OFED_VERSION = daily-* ]]; then
541         local Mmv daily
542         OFED_VERSION=${OFED_VERSION/daily-/}
543         Mmv=${OFED_VERSION%%-*}
544         daily=${OFED_VERSION##$Mmv-}
545         location="http://www.openfabrics.org/downloads/OFED/ofed-${Mmv}-daily/"
546         # find the filename for the version for the date specified
547         OFED_VERSION=$(curl -s "$location" | sed -nre "/${daily}-/s/.*href=\"OFED-(${Mmv//./\\.}-${daily}-[0-9]{4,4}).tgz.*$/\1/p" | tail -1)
548         if [ -z "$OFED_VERSION" ]; then
549             fatal 1 "Could not determine the filename of the OFED snapshot for ${daily}"
550         fi
551     fi
552
553     local file="OFED-${OFED_VERSION}.tgz"
554     download_file "$location/$file" "$KERNELTREE" "$force"
555
556 }
557
558 load_target() {
559
560     EXTRA_VERSION_save="$EXTRA_VERSION"
561     for patchesdir in "$EXTERNAL_PATCHES" \
562                       "$TOPDIR/lustre/lustre/kernel_patches"; do
563         TARGET_FILE="$patchesdir/targets/$TARGET.target"
564         [ -r "$TARGET_FILE" ] && break
565     done
566     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
567
568     echo "Loading target config file $TARGET.target..."
569
570     # if the caller specified an OFED_VERSION it should override whatever
571     # the target file specifies
572     local env_OFED_VERSION="$OFED_VERSION"
573
574     . "$TARGET_FILE"
575
576     if [ -n "$env_OFED_VERSION" ]; then
577         OFED_VERSION="$env_OFED_VERSION"
578     fi
579
580     # doesn't make any sense to build OFED for xen domX's
581     if $XEN; then
582         OFED_VERSION=""
583     fi
584
585     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
586     #       go away and the target just specify the $RPMSMPTYPE
587     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
588
589     # CC might have been overwriten in TARGET_FILE
590     if [[ $CC != ccache\ * ]] && which "$CCACHE" &>/dev/null; then
591         export CCACHE && export CC="ccache $CC"
592     fi
593
594     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
595         KERNELDIR="$KERNELTREE/${lnxmaj}"
596         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
597     fi
598
599     # verify the series is available
600     if [ "$SERIES" ]; then
601         for series in $SERIES; do
602             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
603                 [ -r "$patchesdir/series/$series" ] && continue 2
604             done
605             fatal 1 "Target $TARGET's series $SERIES could not be found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n\t$TOPDIR/lustre/lustre/kernel_patches/series."
606         done
607     fi
608
609     # set the location of the .config file
610     local XENPOSTFIX=""
611     if $XEN; then
612         XENPOSTFIX="-xen"
613     fi
614
615     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
616         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH${RPMSMPTYPE:+-}${RPMSMPTYPE}.config"
617     fi
618
619     local lnxrelnew=${lnxrel//-/_}
620
621     # remember the EXTRA_VERSION before we diddle it here
622     # XXX - we really should not diddle with any values read in from the
623     #       target file.  if we want to modify a value, we should create
624     #       a new variable.
625     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
626
627     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
628         fatal 1 "Config file for target $TARGET missing from $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
629     fi
630
631     if [ "$EXTRA_VERSION_save" ]; then
632         EXTRA_VERSION="$EXTRA_VERSION_save"
633     elif ! $RELEASE; then
634         # if there is no patch series, then this is not a lustre specific
635         # kernel.  don't make it look like one
636         if $PATCHLESS || [ -n "$SERIES" ]; then
637             EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
638 #            EXTRA_VERSION="${EXTRA_VERSION}-${TAG}.${TIMESTAMP}"
639             if ! $PATCHLESS && [ -n "$BUILDID" ]; then
640                 EXTRA_VERSION="${EXTRA_VERSION}.${BUILDID}"
641             fi
642         fi
643     fi
644     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
645
646     ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
647
648     BUILD_ARCHS=
649     for arch in $(uniqify "$ALL_ARCHS"); do
650         if [ -z "$TARGET_ARCHS" ] ||
651            [[ \ $TARGET_ARCHS\  = *\ $arch\ * ]]; then
652             BUILD_ARCHS="$BUILD_ARCHS $arch"
653         fi
654     done
655     [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
656     echo "Building for: $BUILD_ARCHS"
657 }
658
659 tarflags() {
660     local file="$1"
661
662     case "$file" in
663         '')
664             fatal 1 "tarflags(): File name argument missing."
665             ;;
666         *.tar.gz | *.tgz)
667             echo 'zxf'
668             ;;
669         *.tar.bz2)
670             echo 'jxf'
671             ;;
672         *.tar)
673             echo 'xf'
674             ;;
675         *)
676             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
677             ;;
678     esac
679
680 }
681
682 untar() {
683     local tarfile="$1"
684     shift
685     local extractfile="$@"
686
687     echo "Untarring ${tarfile##*/}..."
688     tar $(tarflags "$tarfile") "$tarfile" $extractfile
689
690 }
691
692 unpack_ofed() {
693
694     if ! untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
695         return 1
696     fi
697     [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
698
699 }
700
701 unpack_lustre() {
702
703     if [ -z "$LUSTRE" ]; then
704         local DATESTAMP=""
705
706         if [ -n "$USE_DATESTAMP" ]; then
707             DATESTAMP="-D '$DATE'"
708         fi
709
710         local DIRNAME="lustre-$TAG-$TIMESTAMP"
711
712         cvs -d "$CVSROOT" -qz3 co $DATESTAMP -d "$DIRNAME" lustre || \
713             fatal 1 "There was an error checking out toplevel Lustre from CVS."
714         pushd "$DIRNAME" > /dev/null
715         ./lustrecvs "$TAG" || \
716             fatal 1 "There was an error checking out Lustre/Portals/Build from CVS."
717         echo "Creating lustre tarball..."
718         sh autogen.sh || fatal 1 "There was an error running autogen.sh."
719         ./configure --enable-dist || \
720             fatal 1 "There was an error running ./configure to create makefiles."
721         make dist || fatal 1 "There was an error running 'make dist'."
722         LUSTRE=$PWD/lustre-*.tar.gz
723         popd > /dev/null
724     fi
725
726     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
727     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
728
729 }
730
731 do_patch_linux() {
732
733     local do_patch=${1:-true}
734
735     FULL_PATCH="$PWD/lustre-kernel-${TARGET}-${EXTRA_VERSION}.patch"
736     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
737     $do_patch && pushd linux >/dev/null
738     for series in $SERIES; do
739         echo -n "Applying series $series:"
740         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
741             [ -r "$patchesdir/series/$series" ] || continue
742             SERIES_FILE="$patchesdir/series/$series"
743             for patch in $(<"$SERIES_FILE"); do
744                 echo -n " $patch"
745                 PATCH_FILE="$patchesdir/patches/$patch"
746                 [ -r "$PATCH_FILE" ] || \
747                     fatal 1 "Patch $patch does not exist in Lustre tree."
748                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
749                     rm -f $FULL_PATCH
750                     fatal 1 "Error adding patch $patch to full patch."
751                 }
752                 if $do_patch; then
753                     patch -s -p1 < "$PATCH_FILE" 2>&1 || {
754                         rm -f $FULL_PATCH
755                         fatal 1 "Error applying patch $patch."
756                     }
757                 fi
758             done
759             break
760         done
761         echo
762     done
763     $do_patch && popd >/dev/null
764     echo "Full patch has been saved in ${FULL_PATCH##*/}."
765
766 }
767
768 build_lustre() {
769     local linux="$1"
770     local linuxobj="$2"
771
772     cp "$LUSTRE" SOURCES
773
774     pushd lustre >/dev/null
775
776     echo "Building Lustre RPMs for: $BUILD_ARCHS..."
777     local targets arch
778     for arch in $BUILD_ARCHS; do
779         targets="--target $arch $targets"
780     done
781
782     local confoptions=""
783
784     if $PATCHLESS; then
785         confoptions="$confoptions --disable-server"
786     fi
787
788     local rpmbuildopt='-tb'
789     if $NORPM; then
790         rpmbuildopt='-tc'
791         echo NORPM mode. Only compiling.
792     fi
793
794     ( $(skeep_ldiskfs_rpm $TAG) ) || {
795
796         pushd ldiskfs > /dev/null || return 255
797
798         if !  ./configure --enable-dist; then
799             echo "failed to configure in ldiskfs"
800             popd >/dev/null # pushd ldiskfs
801             popd >/dev/null # pushd lustre
802             return 255
803         fi
804
805         if ! make dist 2>&1; then
806             popd >/dev/null # pushd ldiskfs
807             popd >/dev/null # pushd lustre
808             return 255
809         fi
810
811         #cp lustre-ldiskfs*.tar.gz $TOPDIR/SOURCES || \
812         #    fatal 1 "Could not copy lustre-ldiskfs*.tar.gz to $TOPDIR/SOURCES"
813
814         if ! $RPMBUILD $targets $rpmbuildopt lustre-ldiskfs*.tar.gz \
815             --define "configure_args $confoptions ${CONFIGURE_FLAGS}" \
816             --define "kdir $linux" \
817             ${linuxobj:+--define "kobjdir $linuxobj"} \
818             --define "_tmppath /var/tmp" \
819             --define "_topdir $TOPDIR" 2>&1; then
820             popd >/dev/null # pushd ldiskfs
821             popd >/dev/null # pushd lustre
822             return 255
823         fi
824
825         if $DO_SRC; then
826             if ! $RPMBUILD -ts lustre-ldiskfs*.tar.gz \
827                 --define "configure_args $confoptions ${CONFIGURE_FLAGS}" \
828                 --define "kdir $linux" \
829                 ${linuxobj:+--define "kobjdir $linuxobj"} \
830                 --define "_tmppath /var/tmp" \
831                 --define "_topdir $TOPDIR" 2>&1; then
832                 popd >/dev/null # pushd ldiskfs
833                 popd >/dev/null # pushd lustre
834                 return 255
835             fi
836         fi
837         popd >/dev/null # pushd ldiskfs
838
839         # tell lustre where ldiskfs is
840         # XXX - pointing to the RPM BUILD dir is a hack.  we need to flesh
841         #       out the ldiskfs RPM build so that it builds a
842         #       lustre-ldiskfs-devel RPM and install that and point lustre
843         #       to that instead
844         confoptions="$confoptions --with-ldiskfs=$(ls -d $TOPDIR/BUILD/lustre-ldiskfs-*)"
845     }
846
847     # convert the $PATCHLESS boolean to an empty/not-empty boolean
848     # as silly as this seems, it makes the syntax of the rpmbuild command
849     # simpler and not need an eval to deal with the quotes in the quotes
850     local is_patchless=""
851     if $PATCHLESS; then
852         is_patchless="yes"
853     fi
854
855     # ditto for the lustre-tests boolean
856     local lustre_tests=""
857     if ! $LUSTRE_TESTS; then
858         lustre_tests="no"
859     fi
860
861     $RPMBUILD $targets $rpmbuildopt "$LUSTRE" \
862         ${is_patchless:+--define "lustre_name lustre-client"} \
863         ${lustre_tests:+--define "build_lustre_tests 0"} \
864         ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
865         --define "configure_args $confoptions ${CONFIGURE_FLAGS}" \
866         --define "kdir $linux" \
867         ${linuxobj:+--define "kobjdir $linuxobj"} \
868         --define "_tmppath $TMPDIR" \
869         --define "_topdir $TOPDIR" 2>&1 || \
870         fatal 1 "Error building rpms for $BUILD_ARCHS."
871
872     if $DO_SRC; then
873         if ! $RPMBUILD -ts "$LUSTRE" \
874                  ${is_patchless:+--define "lustre_name lustre-client"} \
875                  ${lustre_tests:+--define "build_lustre_tests 0"} \
876                  ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
877                  --define "configure_args $confoptions ${CONFIGURE_FLAGS}" \
878                  --define "kdir $linux" \
879                  ${linuxobj:+--define "kobjdir $linuxobj"} \
880                  --define "_tmppath $TMPDIR" \
881                  --define "_topdir $TOPDIR" 2>&1; then
882             popd
883             return 255
884         fi
885     fi
886     popd >/dev/null
887
888 }
889
890 stage() {
891
892     [ "$STAGEDIR" ] || return 0
893
894     for arch in $BUILD_ARCHS; do
895         rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
896         echo "${0##*/}: Copying RPMs into ${rpmdir}"
897         mkdir -p "${rpmdir}"
898         cp -v RPMS/${arch}/*.rpm "${rpmdir}"
899         if [ -d RPMS/noarch ]; then
900             cp -v RPMS/noarch/*.rpm "${rpmdir}"
901         fi
902     done
903
904     cp -v "$LUSTRE" "$STAGEDIR"
905
906 }
907
908 #check if we need to build separate ldiskfs RPM
909 skeep_ldiskfs_rpm() {
910     local tag="$1"
911
912     local skip=false
913
914     if ! $LDISKFSRPM; then
915         skip=true
916     elif $PATCHLESS; then
917         skip=true
918     else
919         for skiptag in $SKIPLDISKFSRPM; do
920             [[ $tag == $skiptag ]] && skip=true && break
921         done
922     fi
923
924     echo $skip
925
926 }
927
928 set_rpm_smp_type() {
929
930     local infact_arch="${TARGET_ARCH}"
931
932     RPMSMPTYPE=""
933     [ "$infact_arch" == "i586" ] && infact_arch="i686"
934
935     local smp_type
936     for smp_type in $SMP_ARCHS; do
937         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
938     done
939
940     for smp_type in $BIGSMP_ARCHS; do
941         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
942     done
943
944     for smp_type in $PPC64_ARCHS; do
945         [ $infact_arch == $smp_type ] && RPMSMPTYPE=ppc64 && break
946     done
947
948     for smp_type in $DEFAULT_ARCHS; do
949         [ $infact_arch == $smp_type ] && RPMSMPTYPE=default && break
950     done
951
952 }
953
954 # This function takes a linux source pool and digs out the linux release
955 # from it
956 find_linux_release() {
957     local SRCDIR="$1"
958
959     local LINUXRELEASEHEADER=$SRCDIR/include/linux/version.h
960     if [ -s $SRCDIR/include/linux/utsrelease.h ]; then
961         LINUXRELEASEHEADER=$SRCDIR/include/linux/utsrelease.h
962     fi
963
964     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
965
966 }
967
968 # XXX this needs to be re-written as a wrapper around find_rpm
969 #     or just gotten rid of.  :-)
970 find_linux_rpm() {
971     local prefix="$1"
972
973     local pathtorpms="${KERNELRPMSBASE}/${lnxmaj}/${DISTRO}"
974     [ -d $pathtorpms ] || return 255
975
976     local kernelbinaryrpm rpmfile
977     local wanted_kernel="${lnxmaj}${lnxmin}-${lnxrel}"
978
979     local arch ret=1
980     for arch in $TARGET_ARCHS_ALL; do
981         local found_rpm="" rpm
982         for rpm in ${pathtorpms}/${arch}/*.rpm; do
983             if rpm -q --provides -p "$rpm" 2>&3 | grep -q "kernel${prefix} = $wanted_kernel" 2>&3; then
984
985                 found_rpm="$rpm"
986                 ret=0
987                 break
988             fi
989         done
990         [ -f "$found_rpm" ] && break
991     done
992
993     echo "$found_rpm"
994     return $ret
995
996 }
997
998 # unpack kernel(/source/devel) RPM
999 #
1000 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
1001 # needs to completely refactored.  It completely ingores that $BUILD_ARCHS may
1002 # contain a list of arches for which rpmbuild commands (including the one for
1003 # lustre itself)
1004 unpack_linux_devel_rpm() {
1005     local kernelrpm="${1}"
1006
1007     [ -f "$kernelrpm" ] || return 255
1008     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused || return 255
1009
1010     pushd $TOPDIR/reused &>/dev/null || return 255
1011
1012     if ! rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1; then
1013         return 255
1014     fi
1015
1016     # call a distro specific hook, if available
1017     if type -p unpack_linux_devel_rpm-$DISTRO; then
1018         if ! unpack_linux_devel_rpm-$DISTRO "$kernelrpm"; then
1019             return 255
1020         fi
1021     fi
1022
1023     popd &>/dev/null
1024
1025     find_linux_devel_paths $TOPDIR/reused
1026
1027     return 0
1028
1029 }
1030
1031 build_kernel_ib() {
1032     local linux="$1"
1033
1034     # build kernel-ib{,-devel}
1035     local K_SRC="K_SRC"
1036     # ofed 1.3 had a bug in the rpm spec
1037     if [ "$OFED_VERSION" = "1.3" ]; then
1038         K_SRC="KSRC"
1039     fi
1040
1041     local OFED_CORE="--with-core-mod --with-ipoib-mod --with-sdp-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod --with-rds-mod --with-qlgc_vnic-mod --with-madeye-mod"
1042     local OFED_HARDWARE="--with-mthca-mod --with-mlx4-mod --with-mlx4_en-mod --with-cxgb3-mod --with-nes-mod"
1043     # some I/B drivers are architecture dependent and kernel-ib's configure
1044     # does not figure it out for us ~sigh~
1045     case "$TARGET_ARCH" in
1046         ppc64)
1047             OFED_HARDWARE="$OFED_HARDWARE --with-ehca-mod"
1048             ;;
1049     esac
1050     # we're no longer shipping the OFED iSCSI
1051     #OFED_ISCSI="--with-srp-mod --with-srp-target-mod"
1052     ## ISER module has no backport support as of OFED 1.5 (i.e. only builds on
1053     ##kernels >= 2.6.30)
1054     #if [[ $OFED_VERSION = 1.[0-4]* ]]; then
1055     #   OFED_ISCSI="$OFED_ISCSI --with-iser-mod"
1056     #fi
1057
1058     # assume we are just rebuilding the SRPM
1059     local BUILD_TYPE=${BUILD_TYPE:-"--rebuild"}
1060     local SOURCE="${TOPDIR}/OFED/SRPMS/ofa_kernel-*.src.rpm"
1061
1062     # but switch to building from the SPEC if we need to apply patches
1063     if ls ${TOPDIR}/lustre/build/patches/ofed/* >/dev/null; then
1064         BUILD_TYPE="-bb"
1065         rpm --define "_topdir ${TOPDIR}" -ivh $SOURCE
1066         SOURCE="${TOPDIR}/SPECS/ofa_kernel.spec"
1067         local file ed_fragment1 ed_fragment2 n=1
1068         for file in $(ls ${TOPDIR}/lustre/build/patches/ofed/*); do
1069             ed_fragment1="$ed_fragment1
1070 Patch$n: ${file%%*/}"
1071             ed_fragment2="$ed_fragment2
1072 %patch$n -p0"
1073             cp $file ${TOPDIR}/SOURCES
1074             let n=$n+1
1075         done
1076
1077         if [ $n -gt 1 ]; then
1078             ed $SOURCE <<EOF
1079 /^Source: /a
1080 $ed_fragment1
1081 .
1082 /^%setup /a
1083 $ed_fragment2
1084 .
1085 wq
1086 EOF
1087         fi
1088     fi
1089
1090     local linuxrelease=$(find_linux_release "$linux")
1091     if ! $RPMBUILD $BUILD_TYPE --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
1092                   ${FIND_REQUIRES:+--define "__find_requires $FIND_REQUIRES"} \
1093                   --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
1094                   --define "KVERSION ${linuxrelease}" \
1095                   --define "$K_SRC ${linux}" \
1096                   --define "LIB_MOD_DIR /lib/modules/${linuxrelease}/updates" \
1097                   ${OFA_KERNEL_RELEASE:+--define "_release $OFA_KERNEL_RELEASE"} \
1098                   --define "configure_options --without-quilt $OFED_CORE $OFED_HARDWARE $OFED_ISCSI" \
1099                   ${SOURCE} 2>&1; then
1100         fatal 1 "Error building kernel-ib"
1101     fi
1102
1103 }
1104
1105 store_for_reuse() {
1106         local articles="$1"
1107         local module="$2"
1108         local location="$3"
1109         local signature="$4"
1110         local use_links="$5"
1111
1112         local linkflag=""
1113         if $use_links; then
1114             linkflag="l"
1115         fi
1116
1117         location="$location"/"$signature"/"$module"
1118         mkdir -p "$location"
1119         # the cleanup script removes any directory that doesn't have a
1120         # .lastused, so let's try to prevent that as soon as we can
1121         # this solution still slightly racy with the cleanup script
1122         # but the race is a lot tighter now
1123         touch -t 197001010000 "$location/.lastused"
1124         ## use eval/echo here to make sure shell expansions are performed
1125         #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
1126         local article
1127         for article in $(eval echo $articles); do
1128             if ! cp -a${linkflag} "$article" "$location"; then
1129                 error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
1130                 # rename the cache location so that it's not cached
1131                 # product, but is around for analysis
1132                 mv "$location"{,-bad-$(date +%s)} ||
1133                     error "failed to clean up a failed cache attempt" \
1134                           "in \"$location\" -- manual cleanup will be" \
1135                           "necessary"
1136                 return 1
1137             fi
1138         done
1139
1140         # flag the cache as complete (i.e. in case lbuild was previously
1141         # interrupted while caching)
1142         touch "$location/.lastused"
1143
1144         return 0
1145
1146 }
1147
1148 reuse() {
1149     local module="$1"
1150     local dest="$2"
1151     local use_links="${3:-false}"
1152     local signature="$4"
1153
1154     if [ -n "$REUSEBUILD" ] && [ -d "$REUSEBUILD/$signature/$module" ]; then
1155         if [ ! -f "$REUSEBUILD/$signature/$module/.lastused" ]; then
1156             # the .lastused flag is populated at the end of the caching to
1157             # signal that the caching was completed.  if that flag is not
1158             # there, then the cache is invalid (and should be removed in fact)
1159             mv "$REUSEBUILD/$signature/$module"{,-bad-$(date +%s)} ||
1160                 fatal 1 "failed to clean up a bad cache in location $REUSEBUILD/$signature/$module\" -- manual cleanup will be necessary"
1161             return 1
1162         fi
1163
1164         # so that we know how stale this entry is
1165         touch $REUSEBUILD/$signature/$module/.lastused
1166
1167         if $use_links; then
1168             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
1169                 cp -al $REUSEBUILD/$signature/$module/* $dest/
1170             fi
1171         else
1172             # copying is pretty heavy
1173             # cp -a $REUSEBUILD/$signature/$module/* $dest/
1174             # do some creative symlinking instead
1175             local dir
1176             for dir in BUILD SRPMS SPECS; do
1177                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
1178                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
1179                 fi
1180             done
1181             # sources have to be copied by file because we need SOURCES to
1182             # be a dir we can write into
1183 # could overrun ls's arg list here
1184             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
1185             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
1186                 xargs ln -t $dest/SOURCES -s
1187
1188             # same for RPMS/* dirs
1189 # could overrun ls's arg list here
1190             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
1191             local dir
1192             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
1193                 mkdir -p $dest/RPMS/${dir##*/}
1194                 find $dir -type f |
1195                   xargs ln -t $dest/RPMS/${dir##*/} -s
1196             done
1197         fi
1198         return 0
1199     else
1200         return 1
1201     fi
1202 }
1203
1204 basearch() {
1205     local arch="$1"
1206
1207     if [[ $arch = i[3456]86 ]]; then
1208         echo "i386"
1209     else
1210         echo "$arch"
1211     fi
1212
1213 }
1214
1215 #
1216 # in a given directory, find the first rpm matching given requirements
1217 #
1218 find_rpm() {
1219     local dir="$1"
1220     local match_type="$2"
1221     local match="$3"
1222
1223     pushd "$dir" > /dev/null || \
1224         fatal 1 "Unable to chdir to directory \"$dir\" in find_rpm()"
1225
1226     local file
1227     for file in $(ls *.rpm); do
1228         if [ ! -f "$file" ]; then
1229             continue
1230         fi
1231         case "$match_type" in
1232             provides)
1233                 # match is any valid ERE (i.e. given to egrep) match
1234                 if rpm -q --provides -p "$file" 2>&3 | egrep -q "$match"; then
1235                     echo "$file"
1236                     popd >/dev/null
1237                     return 0
1238                 fi
1239                 ;;
1240             *)
1241                 popd >/dev/null
1242                 fatal 1 "Unknown match type \"$match_type\" given to find_rpm()"
1243                 ;;
1244         esac
1245     done
1246
1247     popd >/dev/null
1248     return 1
1249 }
1250
1251 build_kernel_with_srpm() {
1252     local outfd=$1
1253
1254     if [ -z "$outfd" ] || [ $outfd = 1 ]; then
1255         fatal 1 "You must supply a file descriptor to ${FUNCNAME[0]} and it cannot be 1"
1256     fi
1257
1258     # need to generate the patch for this target
1259     do_patch_linux false >&${outfd}    # sets global $FULL_PATCH (yeah, yuck)
1260
1261     # get an md5sum of the kernel patch + config for reuse check
1262     # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1263     #     in BUILD_ARCHS
1264     local release_str
1265     if $RELEASE; then
1266         local release_str="RELEASE=$RELEASE\n"
1267     fi
1268
1269     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1270         local REUSE_SIGNATURE=$({ echo -en $release_str;
1271                                   echo $BUILD_GEN;
1272                                   cat $CONFIG_FILE $TARGET_FILE $FULL_PATCH; } |
1273                                 md5sum | cut -d" " -f1)
1274         # see if we can link to the reuse pool
1275         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1276         #       "library"
1277         local CAN_LINK_FOR_REUSE=false
1278         touch $REUSEBUILD/$$
1279         if cp -al $REUSEBUILD/$$ $TOPDIR/ 2>/dev/null; then
1280             CAN_LINK_FOR_REUSE=true
1281         fi
1282         rm $REUSEBUILD/$$
1283     fi
1284
1285     # the extra version string to use for the kernel (which might be a reused
1286     # kernel, remember)
1287     local kernel_extra_version=""
1288     if ! $USE_BUILD_CACHE || ! reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1289                                    "$REUSE_SIGNATURE"; then
1290         # nothing cached, build from scratch
1291         if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1292             echo "Downloading kernel SRPM"
1293             download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM" >&${outfd}
1294         fi
1295
1296         if ! rpm -ivh $KERNELDIR/$KERNEL_SRPM \
1297                   --define "_topdir $TOPDIR" >&${outfd} 2>&1; then
1298             # should we clean this up or leave it for analysis?
1299             #rm -rf $RPMTOPDIR
1300             fatal 1 "Error installing kernel SRPM."
1301         fi
1302
1303         # put the Lustre kernel patch into the RPM build tree
1304         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1305         prepare_and_build_srpm >&${outfd} ||
1306             fatal 1 "failed to prepare_and_build_srpm"
1307
1308         if [ -z "$REUSE_SIGNATURE" ]; then
1309             echo "No reuse signature was caculated so not storing the built kernel" >&${outfd}
1310         else
1311             # store the resulting kernel RPM build tree for future use
1312             echo "Storing the built kernel for future reuse" >&${outfd}
1313             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1314                                  "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1315                                  "$CAN_LINK_FOR_REUSE"; then
1316                 error "Failed to store kernel RPMS for reuse"
1317                 echo "unknown"
1318                 return 1
1319             fi
1320         fi
1321     fi  # build reuse
1322
1323     # figure out the EXTRA_VERSION of the kernel we built or are re-using
1324     local KERNEL_RPM
1325     if ! KERNEL_RPM=$(find_rpm "$TOPDIR/RPMS/$TARGET_ARCH/" provides "^kernel ="); then
1326         fatal 1 "Failed to find a kernel RPM in $TOPDIR/RPMS/$TARGET_ARCH/"
1327     fi
1328     kernel_extra_version=$(rpm -q --queryformat "%{RELEASE}" -p $TOPDIR/RPMS/$TARGET_ARCH/$KERNEL_RPM)
1329
1330     # should now have the following RPMs
1331     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1332     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1333     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1334     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1335     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1336
1337     echo $kernel_extra_version
1338     return 0
1339
1340 }
1341
1342 # build OFED
1343 # globals used:
1344 #    TOPDIR
1345 #    REUSEBUILD, USE_BUILD_CACHE
1346 #    CONFIGURE_FLAGS
1347
1348 build_ofed() {
1349     local linux="$1"
1350     local ofed_version="$2"
1351
1352     # if an ofed version is given, then it means use OFED proper,
1353     # not any vendor specific "inkernel" version
1354     if [ -z "$ofed_version" ]; then
1355         return 0
1356     fi
1357
1358     if [ "$ofed_version" = "inkernel" ]; then
1359         # see if there is a distro specific override for this and use
1360         # that if it exists
1361         # XXX we need to better integrate a distro specific override with
1362         #     the rest of this function so that all of the reuse cache
1363         #     stuff is leveraged given that 80% of this function is reuse
1364         if type -p build_ofed-${DISTRO}; then
1365             local ofed_location
1366             ofed_location=$(build_ofed-${DISTRO} ${STDOUT})
1367             local rc=${PIPESTATUS[0]}
1368             CONFIGURE_FLAGS="--with-o2ib=${ofed_location} ${CONFIGURE_FLAGS}"
1369             return $rc
1370         else
1371             return 0
1372         fi
1373     fi
1374
1375     # build kernel-ib
1376     if $USE_BUILD_CACHE && [ -n "$REUSEBUILD" ]; then
1377         local REUSE_SIGNATURE=$({ echo "$ofed_version";
1378                                   echo "$(find_linux_release ${linux})";
1379                                   cat "${linux}/include/linux/autoconf.h"; } |
1380                                 md5sum | cut -d" " -f1)
1381         # see if we can link to the reuse pool
1382         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse
1383         #       "library"
1384         local CAN_LINK_FOR_REUSE=false
1385         touch $REUSEBUILD/$$
1386         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1387             CAN_LINK_FOR_REUSE=true
1388         fi
1389         rm $REUSEBUILD/$$
1390     fi
1391
1392     if ! $USE_BUILD_CACHE || ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1393                                    "$REUSE_SIGNATURE"; then
1394         if [ -n "$REUSE_SIGNATURE" ]; then
1395             # stash away the existing built articles for a moment
1396             mkdir bak
1397             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1398             function mv_back {
1399                 pushd bak
1400                 find . | cpio -pudlm ..
1401                 popd
1402                 rm -rf bak
1403             }
1404             create_rpmbuild_dirs
1405         fi
1406         # build it
1407         build_kernel_ib "${linux}"
1408
1409         if [ -z "$REUSE_SIGNATURE" ]; then
1410             echo "No reuse signature was caculated so not storing the built ofed"
1411         else
1412             # store the resulting RPM build tree for future use
1413             echo "Storing the built ofed for future reuse"
1414             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1415                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1416                                  "$CAN_LINK_FOR_REUSE"; then
1417                 error "Failed to store OFED RPMS for reuse"
1418                 mv_back
1419                 return 1
1420             fi
1421             # put the stuff we stashed away back
1422             mv_back
1423         fi
1424     fi
1425
1426     pushd "$TOPDIR" >/dev/null
1427     rm -rf kernel-ib-devel
1428     mkdir kernel-ib-devel
1429     cd kernel-ib-devel
1430     # the actual ofed RPMs don't have the -rc$n or -$date string appened that
1431     # might be present on the file
1432     local linuxrelease=$(find_linux_release "$linux")
1433     ofed_version=$(echo $ofed_version |
1434                    sed -re 's/-(20[0-9]{6,6}-[0-9]{4,4}|rc[0-9]*)$//')
1435     local rpm=$(ls $TOPDIR/RPMS/*/kernel-ib-devel-${ofed_version}-${linuxrelease//-/_}.*.rpm)
1436     if ! rpm2cpio < $rpm | cpio -id; then
1437         fatal 1 "could not unpack the kernel-ib-devel rpm."
1438     fi
1439     CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/ofa_kernel ${CONFIGURE_FLAGS}"
1440     popd >/dev/null
1441
1442 }
1443
1444 build_with_srpm() {
1445
1446     if ! $PATCHLESS; then
1447         local kernel_extra_version
1448         if ! kernel_extra_version=$(build_kernel_with_srpm ${STDOUT}); then
1449             fatal 1 "Failed to build the kernel from it's SRPM"
1450         fi
1451
1452         for arch in $BUILD_ARCHS; do
1453             local kernel_devel_rpm
1454             if ! kernel_devel_rpm=$(find_rpm "$TOPDIR/RPMS/$arch/" provides "^$(devel_kernel_name $KERNEL_LUSTRE_NAMING) ="); then
1455                 fatal 1 "Failed to find a kernel development RPM in $TOPDIR/RPMS/$arch/"
1456             fi
1457
1458             # install the -devel RPM in preparation for modules builds
1459             if ! lnxrel="$kernel_extra_version" unpack_linux_devel_rpm \
1460                            "$TOPDIR/RPMS/$arch/$kernel_devel_rpm"; then
1461                 fatal 1 "Could not find the Linux tree in $TOPDIR/RPMS/$arch/$kernel_devel_rpm"
1462             fi
1463         done
1464     else
1465         # need to find and unpack the vendor's own kernel-devel for patchless
1466         # client build
1467         local kernelrpm
1468         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE"); then
1469             fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in ${KERNELRPMSBASE}/${lnxmaj}/${DISTRO}"
1470         fi
1471         if ! lnxrel="$lnxrel" unpack_linux_devel_rpm "$kernelrpm" "-"; then
1472             fatal 1 "Could not find the Linux tree in $kernelrpm"
1473         fi
1474     fi
1475
1476     # ~sigh~  have to make copies of and modify some of the rpm
1477     # infrastructure files so that find-requires can find our unpacked
1478     # kernel-devel artifacts
1479     cp $RPM_HELPERS_DIR/{symset-table,find-requires{,.ksyms}} .
1480     FIND_REQUIRES="$(pwd)/find-requires"
1481     chmod 755 {symset-table,find-requires{,.ksyms}}
1482     local tmp="$(pwd)"
1483     tmp="${tmp//\//\\/}"
1484     ed find-requires <<EOF
1485 1a
1486 set -x
1487 .
1488 /|.*find-requires.ksyms/s/|/| bash -x/
1489 g/ [^ ]*\/\(find-requires\.ksyms\)/s// $tmp\/\1/g
1490 wq
1491 EOF
1492     ed find-requires.ksyms <<EOF
1493 1a
1494 set -x
1495 .
1496 g/\/.*\/\(symset-table\)/s//$tmp\/\1/g
1497 wq
1498 EOF
1499     ed symset-table <<EOF
1500 1a
1501 set -x
1502 .
1503 g/\(\/boot\/\)/s//$tmp\/reused\1/g
1504 g/\(\/usr\/src\/kernels\/\)/s//$tmp\/reused\1/g
1505 wq
1506 EOF
1507
1508     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1509         fatal 1 "error building OFED"
1510
1511     # now build Lustre
1512     if build_lustre "$LINUX" "$LINUXOBJ"; then
1513         # the build worked.  resolve any symlinked files (i.e. from reuse)
1514         # in RPMS/$arch to real files so that that that huge mess of
1515         # complication known as LTS can copy them yet somewhere else.
1516         # is it any wonder this whole process is so damn so?  anyone ever
1517         # heard of hardlinks?  it's this cool new thing that allows you save
1518         # tons of time and space by creating... well you can go read about
1519         # them if you have not heard about them yet.
1520         # can i say how much the implemenation of all of this really impedes
1521         # RPM reuse?
1522         local dir
1523         for dir in RPMS/*; do
1524             pushd $dir
1525             for file in $(ls); do
1526                 if [ -h $file ]; then
1527                     cp $file foo
1528                     mv foo $file
1529                 fi
1530             done
1531             popd
1532         done
1533         # also, for i?86, make sure all of the RPMs are in RPMS/$TARGET_ARCH
1534         # as that's where LTS expects to find them
1535         for dir in RPMS/*; do
1536             if [ $dir = RPMS/$TARGET_ARCH ]; then
1537                 continue
1538             fi
1539             pushd $dir
1540             local files=$(ls)
1541             if [ -n "$files" ]; then
1542                 cp -al $files ../$TARGET_ARCH
1543             fi
1544             popd
1545         done
1546     else
1547         return 1
1548     fi
1549
1550 }
1551
1552 create_rpmbuild_dirs() {
1553
1554     [ -d RPMS ] || mkdir RPMS
1555     for arch in $BUILD_ARCHS; do
1556         if [[ $arch = i?86 ]]; then
1557             # some stupidity in the sles11 kernel spec requires an RPMS/i386
1558             # even if the target arch is i686
1559             [ -d RPMS/i386 ] || mkdir RPMS/i386
1560         fi
1561         [ -d RPMS/$arch ] || mkdir RPMS/$arch
1562     done
1563     [ -d BUILD ] || mkdir BUILD
1564     [ -d SOURCES ] || mkdir SOURCES
1565     [ -d SPECS ] || mkdir SPECS
1566     [ -d SRPMS ] || mkdir SRPMS
1567
1568 }
1569
1570 new_list() {
1571
1572     echo ""
1573
1574 }
1575
1576 add_list() {
1577     local list="$1"
1578     local item="$2"
1579
1580     echo "$list $item"
1581
1582 }
1583
1584 is_list_member() {
1585     local list="$1"
1586     local item="$2"
1587
1588     [[ $list\  == *\ $item\ * ]]
1589
1590 }
1591
1592 #########################################################################
1593 # Generate a backtrace through the call stack.
1594 #
1595 # Input: None
1596 # Output: None
1597 #########################################################################
1598 backtrace() {
1599     local strip=${1:-1}
1600
1601     local funcname="" sourcefile="" lineno="" n
1602
1603     echo "Call stack: (most recent first)"
1604     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1605         funcname=${FUNCNAME[$n - 1]}
1606         sourcefile=$(basename ${BASH_SOURCE[$n]})
1607         lineno=${BASH_LINENO[$n - 1]}
1608         if [ $n = 1 ]; then
1609             let lineno-=11
1610         fi
1611         # Display function arguments
1612         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1613             local args newarg j p=0
1614             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1615                 newarg=${BASH_ARGV[$j + $p - 1]}
1616                 args="${args:+${args} }'${newarg}'"
1617             done
1618             let p+=${BASH_ARGC[$n - 1]}
1619         fi
1620         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1621     done
1622
1623     echo
1624     echo "BEGIN BACKTRACE"
1625
1626     #echo ${BASH_LINENO[*]}
1627     #echo ${BASH_SOURCE[*]}
1628     #echo ${FUNCNAME[*]}
1629     local i=$((${#FUNCNAME[@]} - 1))
1630     while [ $i -ge 0 ]; do
1631         local lineno=${BASH_LINENO[$i]}
1632         if [ $i = 0 ]; then
1633             let lineno-=11
1634         fi
1635         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${lineno}"
1636         # Can't figure out how to get function args from other frames...
1637         local FUNCTION="${FUNCNAME[$i]}()"
1638         echo "$SOURCELINE:$FUNCTION"
1639         i=$((i - 1))
1640     done
1641
1642     echo "END BACKTRACE"
1643
1644     echo $BACKTRACE
1645
1646 }
1647
1648 seen_list=$(new_list)
1649 trap 'set +x;
1650 echo "An unexpected error has occurred at ${BASH_SOURCE[0]##*/}:$((LINENO-1)).
1651 Unfortunately the above line number in the message may or may not be correct,
1652 but details have been send to the lbuild maintainer.  Attempting to continue."; (echo "Untrapped error"
1653 echo
1654 # have we seen this one
1655 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1656
1657 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1658   echo "seen this one already"
1659 else
1660   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1661 fi
1662 backtrace
1663 echo
1664 echo "Environment:"
1665 set
1666 ) | mail -s "Untrapped error at ${BASH_SOURCE[0]##*/}:$((LINENO-15)) on $HOSTNAME" brian@sun.com >&2; set $xtrace' ERR
1667 set -E
1668
1669 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1670
1671 options=$(getopt -o d:D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ldiskfs,ccache,reuse:,norpm,disable-datestamp,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,ofed-version:,publish,release,set-value:,src,stage:,tag:,target:,target-archs:,with-linux:,xen -- "$@")
1672
1673 if [ $? != 0 ]; then
1674     usage 1
1675 fi
1676
1677 eval set -- "$options"
1678
1679 while [ "$1" ]; do
1680     case "$1" in
1681         '')
1682             usage 1
1683             ;;
1684         --ccache)
1685             CCACHE='ccache'
1686             shift
1687             ;;
1688         -d)
1689             CVSROOT=$2
1690             shift 2
1691             ;;
1692         -D)
1693             DATE=$2
1694             shift 2
1695             ;;
1696         --external-patches)
1697             EXTERNAL_PATCHES=$2
1698             shift 2
1699             ;;
1700         --extraversion)
1701             EXTRA_VERSION=$2
1702             shift 2
1703             ;;
1704         --help | -h)
1705             usage 0
1706             ;;
1707         --kerneldir)
1708             KERNELDIR=$2
1709             shift 2
1710             ;;
1711         --kerneltree)
1712             if ! KERNELTREE=$(canon_path "$2"); then
1713                 fatal 1 "Could not determine the canonical location of $2"
1714             fi
1715             shift 2
1716             ;;
1717         --linux | --with-linux)
1718             if ! LINUX=$(canon_path "$2"); then
1719                 fatal 1 "Could not determine the canonical location of $2"
1720             fi
1721             shift 2
1722             ;;
1723         --distro)
1724             DISTRO=$2
1725             shift 2
1726             ;;
1727         --reuserpm)
1728             REUSERPM=$2
1729             shift 2
1730             ;;
1731         --reusebuild)
1732             if ! REUSEBUILD=$(canon_path "$2"); then
1733                 fatal 1 "Could not determine the canonical location of $2"
1734             fi
1735             shift 2
1736             ;;
1737         --norpm)
1738             NORPM=true
1739             shift
1740             ;;
1741         --ldiskfs)
1742             LDISKFSRPM=true
1743             shift
1744             ;;
1745         --patchless)
1746             PATCHLESS=true
1747             shift
1748             ;;
1749         --kernelrpm)
1750             if ! KERNELRPMSBASE=$(canon_path "$2"); then
1751                 fatal 1 "Could not determine the canonical location of $2"
1752             fi
1753             shift 2
1754             ;;
1755         --timestamp)
1756             TIMESTAMP=$2
1757             shift 2
1758             ;;
1759         --lustre)
1760             if ! LUSTRE=$(canon_filepath "$2"); then
1761                 fatal 1 "Could not determine the canonical location of $2"
1762             fi
1763             shift 2
1764             ;;
1765         --nodownload)
1766             DOWNLOAD=false
1767             shift 1
1768             ;;
1769         --nosrc)
1770             DO_SRC=false
1771             shift 1
1772             ;;
1773         --ofed-version)
1774             OFED_VERSION="$2"
1775             shift 2
1776             ;;
1777         --publish)
1778             shift
1779             ;;
1780         --release)
1781             RELEASE=true
1782             shift
1783             ;;
1784         --src)
1785             DO_SRC=true
1786             shift 1
1787             ;;
1788         --stage)
1789             STAGEDIR=$2
1790             shift 2
1791             ;;
1792         --tag)
1793             TAG=$2
1794             shift 2
1795             ;;
1796         --target)
1797             TARGET=$2
1798             shift 2
1799             ;;
1800         --target-archs)
1801             TARGET_ARCHS=$2
1802             shift 2
1803             ;;
1804         --disable-datestamp)
1805             USE_DATESTAMP=
1806             shift
1807             ;;
1808         --xen)
1809             XEN=true
1810             shift
1811             ;;
1812         --set-value)
1813             eval $2
1814             shift 2
1815             ;;
1816         --)
1817             shift
1818             # there are actually some lustre configure flags that we need to
1819             # handle ourselves (but we still give them to configure)
1820             if [[ \ $@\  == *\ --disable-tests\ * ]]; then
1821                 LUSTRE_TESTS=false
1822             fi
1823             CONFIGURE_FLAGS=$@
1824             CONFIGURE_FLAGS="$CONFIGURE_FLAGS --enable-liblustre --enable-liblustre-tests"
1825             break
1826             ;;
1827         *)
1828             usage 1 "Unrecognized option: $1"
1829             ;;
1830     esac
1831 done
1832
1833 check_options
1834
1835 unpack_lustre
1836
1837 # XXX - should we _always_ get the buildid from the META file?  what are the
1838 # other (i.e. non-lustre-tarball use cases of lbuild)?
1839 BUILDID=$(sed -ne '/^BUILDID =/s/.*= *//p' lustre/META)
1840
1841 load_target
1842
1843 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
1844     download_ofed
1845     unpack_ofed || fatal 1 "Error unpacking OFED tarball"
1846 fi
1847
1848 # make sure the RPM build environment is set up
1849 create_rpmbuild_dirs
1850
1851 # if an unpacked kernel source tree was given on the command line
1852 # just build lustre with it (nothing distro kernel specific here)
1853 if [ -n "$LINUX" ]; then
1854     build_ofed "${LINUXOBJ:-$LINUX}" "$OFED_VERSION" ||
1855         fatal 1 "error building OFED"
1856     build_lustre "$LINUX" "$LINUXOBJ"
1857 else
1858     if [ -f "${0%/*}/lbuild-$DISTRO" ]; then
1859         source ${0%/*}/lbuild-$DISTRO
1860
1861         build_with_srpm || fatal 1 "Failed to build_with_srpm"
1862     else
1863         EXTRA_VERSION_DELIMITER=${EXTRA_VERSION_DELIMITER:-"-"}
1864         source ${0%/*}/lbuild.old_school
1865
1866         old_school_download_kernel
1867
1868         build_success=false
1869         if $PATCHLESS; then
1870             patchless_build_sequence && build_success=true
1871         else
1872             [ "$DISTRO" = "sles9" ] && build_sequence_rpm_reuse && build_success=true
1873             if ! $build_success; then
1874                 build_sequence_reuse && build_success=true
1875                 if ! $build_success; then
1876                     build_sequence && build_success=true
1877                     if $build_success; then
1878                         store_for_reuse || echo "Cannot store for future reuse"
1879                     fi
1880                 fi
1881             fi
1882         fi
1883         ( $build_success ) || fatal 1 "Cannot build lustre"
1884     fi
1885 fi
1886
1887 stage